const { buildModule } = require("@nomicfoundation/hardhat-ignition/modules");

module.exports = buildModule("DufyNFTModule", (m) => {
    // Paramètres de déploiement
    const defaultRoyaltyReceiver = m.getParameter("defaultRoyaltyReceiver");
    const contractOwner = m.getParameter("contractOwner");

    // Déploiement du contrat
    const dufyNFT = m.contract("DufyNFT", [defaultRoyaltyReceiver, contractOwner]);

    // Mint automatique de 5 NFTs après le déploiement
    const tokenURIs = [
        "bafkreidhjka7zk33j56eyhebzhjuhwrgy3ilploxaofzkv24pl2oib7434",
        "bafkreicp3koc6cgybjr355ucgg3z26657zsvxfuyugyodaz76k3wh35fca",
        "bafkreicergmuw7h3cma7r2gn6z722b2entpft4y3q452z6ylkalt4tarai",
        "bafkreie3gw7wj5r6eodljghloaakijdrmcduth7afwu3bp4dif5edi3knu",
        "bafkreieuenwafbt4qpykm6lffsikorl2mtgkf75vwfyqgm2aqfsxjzqhjq"
    ];
    const fingerprints = [
        "fingerprint1",
        "fingerprint2",
        "fingerprint3",
        "fingerprint4",
        "fingerprint5"
    ];
    const prices = [
        m.getParameter("price1"),
        m.getParameter("price2"),
        m.getParameter("price3"),
        m.getParameter("price4"),
        m.getParameter("price5")
    ];
    const royalties = [
        m.getParameter("royalty1"),
        m.getParameter("royalty2"),
        m.getParameter("royalty3"),
        m.getParameter("royalty4"),
        m.getParameter("royalty5")
    ];

    for (let i = 0; i < 5; i++) {
        m.call(dufyNFT, "mintNFT", {
            args: [contractOwner, tokenURIs[i], fingerprints[i], prices[i], royalties[i]]
        });
    }

    return { dufyNFT };
});
